<?php
namespace Claromentis\Core\Like\Controller;

$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"] ?: array()) + array("_2409bed918465b496e" . "1f712f2c651403" => base64_decode("bGlrZXJzLmRhdGFzc" . "mM="), "_4d707fab93bebb00bbe" . "69e8159697c90" => base64_decode(""), "_71f564ea75084c6f261db81c655d2" . "f73" => base64_decode("cHJvZmlsZV9saW5rLmh" . "yZWY="), "_532af4669410" . "18fd3954ccc8a" . "ed6a235" => base64_decode("bG" . "lr" . "ZW" . "Q="), "_5203b6250b088a619af741a56f3a0c2" . "6" => base64_decode("Y29tbW9uL2xpa2UvbGlrZXJzX2xpc3QuaHR" . "tbA=="), "_62d701c3c5340" . "4f06345eb35720" . "a47b4" => base64_decode("aXNfbnV" . "tZXJpYw" . "=="), "_5784e706ef84e048186a70a164" . "fcc358" => base64_decode("T2JqZWN0IElEIGlzIG5vdCBzcGVjaWZp" . "ZWQgb3IgaW52YWxpZA=="), "_5e8488c301cda0" . "085b5ca6c78c506" . "87d" => base64_decode("cHJvZm" . "lsZV9w" . "aG90by" . "5zcmM="), "us" . "er" . "_i" . "d" => base64_decode("dXNlcl9" . "pZA=="), "_aa45d9a" . "a411eac8" . "90badddf" . "edf2ade3" . "8" => base64_decode("T2JqZWN0IHR5cGUgaXMgbm90IH" . "NwZWNpZmllZA=="), "_f4eafa5f49330" . "6ffdb51a688b21" . "dd507" => base64_decode("dG90YWw" . "="), "_37317e99fd1ac0bd2" . "cca360fcc5fd612" => base64_decode("dXNlcl9" . "uYW1lLm" . "JvZHk="));
use Claromentis\Core\Application;
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\StatusCode;
use Psr\Http\Message\ServerRequestInterface as Request;
use Claromentis\Core\Http\TemplaterCallResponse;
use RestFormat;






class RestV2Controller
{
    
    
    
    
    protected $formatter;
    
    
    
    
    public function __construct(RestFormat $formatter)
    {
        $this->formatter = $formatter;
    }
    
    
    
    
    
    
    
    
    public function AddLike(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $app->likes->Add($aggregation, $object_id, $app->security->GetUserId());
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_f4eafa5f493306" . "ffdb51a688b21dd" . "507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d, StatusCode::OK);
    }
    public function RemoveLike(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $app->likes->Remove($aggregation, $object_id, $app->security->GetUserId());
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_f4eafa5f493306ffdb51a688b" . "21dd507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d, StatusCode::OK);
    }
    
    
    
    
    
    
    
    
    public function GetMeLiked(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_532af46694101" . "8fd3954ccc8aed" . "6a235"] => (bool) $app->likes->IsLiked($aggregation, $object_id, $app->security->GetUserId())];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    public function GetLikesCount(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_f4eafa5f493306ff" . "db51a688b21dd507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikes(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $_f4eafa5f493306ffdb51a688b21dd507 = $app->likes->GetCount($aggregation, $object_id);
        if ($_f4eafa5f493306ffdb51a688b21dd507 > 0) {
            $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        } else {
            $likes = [];
        }
        $_1f24efd4735b7a11b391147435e7d35d = $this->formatter->PagingContainer($likes, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2, $_f4eafa5f493306ffdb51a688b21dd507);
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikesHtml(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        $_e7438083ff42e99584f6022253250369 = [];
        foreach ($likes as $_9ecb1a728fdb50fbae4581f824a09366) {
            $user_id = $_9ecb1a728fdb50fbae4581f824a09366[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["user" . "_id"]];
            $_343a395319323dd7609bcbc465b4d034 = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_71f564ea75084c6f261db81c655d2f7" . "3"] => \User::GetProfileUrl($user_id), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_5e8488c3" . "01cda0085" . "b5ca6c78c" . "50687d"] => \User::GetPhotoUrl($user_id), $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_37317e99fd1ac0bd2cca360fcc5fd61" . "2"] => \User::GetNameById($user_id)];
            if ($_343a395319323dd7609bcbc465b4d034[$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_37317e99fd1ac0bd2cca360fcc5" . "fd612"]] != $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_4d707fa" . "b93bebb0" . "0bbe69e8" . "159697c9" . "0"]) {
                
                
                $_e7438083ff42e99584f6022253250369[] = $_343a395319323dd7609bcbc465b4d034;
            }
        }
        $args = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_2409bed9184" . "65b496e1f712" . "f2c651403"] => $_e7438083ff42e99584f6022253250369];
        $template = $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_5203b6250b088a619af" . "741a56f3a0c26"];
        return new TemplaterCallResponse($template, $args);
    }
    
    
    
    
    
    
    private function CheckObject($object_type, $object_id, Application $app)
    {
        if (!$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_62d701c3c5340" . "4f06345eb35720" . "a47b4"]($object_type)) {
            $aggregation = \ClaAggregations::GetNumByCode($object_type);
        } elseif ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_62d701c3" . "c53404f06" . "345eb3572" . "0a47b4"]($object_type)) {
            $aggregation = (int) $object_type;
        }
        if (empty($aggregation)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_aa45d9aa411eac890badddfed" . "f2ade38"]);
        }
        if (!$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_62d701c3c53404f06345eb35720a4" . "7b4"]($object_id)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_5784e706ef84e04" . "8186a70a164fcc35" . "8"]);
        }
        
        
        return array($aggregation, $object_id);
    }
}